<?php
	/*------------------------------------------------------------------------------
   $Id$

   AbanteCart, Ideal OpenSource Ecommerce Solution
   http://www.AbanteCart.com

   Copyright © 2011 Belavier Commerce LLC

   This source file is subject to Open Software License (OSL 3.0)
   License details is bundled with this package in the file LICENSE.txt.
   It is also available at this URL:
   <http://www.opensource.org/licenses/OSL-3.0>

  UPGRADE NOTE:
	Do not edit or add to this file if you wish to upgrade AbanteCart to newer
	versions in the future. If you wish to customize AbanteCart for your
	needs please refer to http://www.AbanteCart.com for more information.
 ------------------------------------------------------------------------------*/
	if (!defined('DIR_CORE')) {
		header('Location: static_pages/');
	}

class ControllerPagesExtensionRewardPoints extends AController {

	public $data = array();
	private $error = array();

    public function main() {

		//init controller data
		$this->extensions->hk_InitData($this, __FUNCTION__);

		$this->loadLanguage('reward_points/reward_points');
		$this->document->setTitle( $this->language->get('reward_points_name') );

		$this->view->assign('success', $this->session->data['success']);
		if (isset($this->session->data['success'])) {
			unset($this->session->data['success']);
		}

		if ( isset($this->request->get['object_name']) ) {
			$this->object_name = $this->request->get['object_name'];
		} else {
			$this->object_name = 'customer_group';
		}

		$params = '&object_name=' . $this->object_name;

		if ( isset($this->request->get['object_id']) ) {
			$params .= '&object_id=' . $this->request->get['object_id'];
			$method_name = '_get_'. $this->object_name .'_tabs';
			if ( method_exists($this, $method_name) ) {
				$this->{$method_name}($this->request->get['object_id']);
			}
		}

		$this->document->initBreadcrumb( array (
			'href'      => $this->html->getSecureURL('index/home'),
			'text'      => $this->language->get('text_home'),
			'separator' => FALSE
		));

		if ( $this->object_name != 'customer_group' ) {
			$this->document->addBreadcrumb( array (
				'href'      => $this->html->getSecureURL('catalog/' . $this->object_name),
				'text'      => $this->language->get('text_' .$this->object_name),
				'separator' => ' :: '
			));
		}

		$this->document->addBreadcrumb( array (
			'href'      => $this->html->getSecureURL('extension/reward_points', $params),
			'text'      => $this->language->get('reward_points_name'),
			'separator' => ' :: '
		));

		$grid_settings = array(
			//id of grid
			'table_id' => 'rp_grid',
			// url to load data from
			'url' => $this->html->getSecureURL('listing_grid/reward_points', $params),
			'editurl' => $this->html->getSecureURL('listing_grid/reward_points/update', $params),
			'update_field' => $this->html->getSecureURL ( 'listing_grid/reward_points/update_field', $params ),
			'sortname' => 'customer_group',
			'sortorder' => 'asc',
			'multiselect' => 'true',
			'columns_search' => false,
			'multiaction_options' => array('save' => $this->language->get('text_save_selected')),
			// actions
			'actions' => array(
				'save' => array(
					'text' => $this->language->get('button_save'),
				),
			),
		);

		$grid_settings['colNames'] = array(
			$this->language->get('customer_group_name'),
			$this->language->get('text_amount'),
			$this->language->get('text_amount_modificator'),
		);

		$grid_settings['colModel'] = array(
			array(
				'name' => 'customer_group_name',
				'index' => 'customer_group_name',
				'width' => 100,
				'align' => 'center',
				'sortable' => true,
				'search' => false
			),
			array(
				'name' => 'reward_points_amount',
				'index' => 'reward_points_amount',
				'width' => 100,
				'align' => 'center',
				'sortable' => true,
				'search' => false
			),
			array(
				'name' => 'amount_modificator',
				'index' => 'amount_modificator',
				'width' => 100,
				'align' => 'center',
				'sortable' => false,
				'search' => false
			),
		);

		if ( $this->object_name == 'customer_group' ) {
			$grid_settings['colNames'][] = $this->language->get('text_combine_or_override');

			$grid_settings['colModel'][] = array(
				'name' => 'combine_or_override',
				'index' => 'combine_or_override',
				'width' => 100,
				'align' => 'center',
				'sortable' => false,
				'search' => false
			);

		}

		$grid = $this->dispatch('common/listing_grid', array( $grid_settings ) );
		$this->view->assign('listing_grid', $grid->dispatchGetOutput());

		$this->view->assign('heading_title', $this->language->get('reward_points_name') );

		$help_name = 'reward_points';
		if ( $this->request->get['object_name'] ) {
			$this->request->get['object_name'] . '_listing';
		}

		$this->view->assign('help_url', $this->gen_help_url($help_name) );

		$this->view->batchAssign($this->data);
		$this->processTemplate('pages/extension/reward_points_grid.tpl' );

		//update controller data
		$this->extensions->hk_UpdateData($this, __FUNCTION__);

	}

	public function customer() {
		//init controller data
		$this->extensions->hk_InitData($this,__FUNCTION__);

		$this->loadLanguage('reward_points/reward_points');
		$this->loadModel('extension/reward_points');
		$this->loadModel('sale/customer');

		$this->document->setTitle( $this->language->get('reward_points_name') );

		if (isset($this->session->data['success'])) {
			$this->data['success'] = $this->session->data['success'];
			unset($this->session->data['success']);
		}
		if (isset($this->session->data['error'])) {
			$this->data['error'] = $this->session->data['error'];
			unset($this->session->data['error']);
		}

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->_validateForm()) {
			if ( $this->model_extension_reward_points->setCustomerRewardPoints($this->request->get['customer_id'], $this->request->post['points_amount']) ) {
				$this->model_extension_reward_points->updateHistory(
					array(
						'customer_id' => $this->request->get['customer_id'],
						'amount' => $this->request->post['points_amount'],
						'action' => 'M', // manual set
						'source' => 'admin',
						'source_id' => 0,
						'comment' => $this->request->post['comment']
					)
				);
			}

			$this->session->data['success'] = $this->language->get('text_customer_points_set_success');
			$this->redirect( $this->html->getSecureURL('extension/reward_points/customer', '&customer_id=' . $this->request->get['customer_id'] ) );
		}

		$this->_getForm();

		//update controller data
		$this->extensions->hk_UpdateData($this,__FUNCTION__);
	}

	private function _getForm() {

		$this->data['token'] = $this->session->data['token'];

		$this->document->initBreadcrumb( array (
			'href'      => $this->html->getSecureURL('index/home'),
			'text'      => $this->language->get('text_home'),
			'separator' => FALSE
		));
		$this->document->addBreadcrumb( array (
			'href'      => $this->html->getSecureURL('sale/customer'),
			'text'      => $this->language->get('text_customers'),
			'separator' => ' :: '
		));

		$this->data['cancel'] = $this->html->getSecureURL('sale/customer');

		if (isset($this->request->get['customer_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$customer_info = $this->model_sale_customer->getCustomer($this->request->get['customer_id']);
		}

		$this->document->addBreadcrumb( array (
			'href'      => $this->data['action'],
			'text'      => $this->language->get('text_edit') . $this->language->get('text_customer') . ' - ' . $customer_info['firstname'] . ' ' . $customer_info['lastname'],
			'separator' => ' :: '
		));

		$this->document->addBreadcrumb( array (
			'href'      => $this->html->getSecureURL('extension/reward_points/customer', '&customer_id=' . $this->baseObject->request->get['customer_id']),
			'text'      => $this->language->get('reward_points_name'),
			'separator' => ' :: '
		));

		$this->data['tabs'] = array(
			array(
				'link' => $this->html->getSecureURL('sale/customer/update', '&customer_id=' . $this->request->get['customer_id']),
				'text' => $this->language->get('text_general'),
				'class' => ''
			),
			array(
				'link' => $this->html->getSecureURL('extension/reward_points/customer', '&customer_id=' . $this->request->get['customer_id']),
				'text' => $this->language->get('reward_points_name'),
				'class' => 'active'
			)
		);

		$customer_points_info = $this->model_extension_reward_points->getCustomerRewardPoints($this->request->get['customer_id']);

		$this->data['points_gained'] = empty($customer_points_info) ? 0 : $customer_points_info['points_amount'];

		$this->data['action'] = $this->html->getSecureURL('extension/reward_points/customer', '&customer_id=' . $this->request->get['customer_id'] );
		$this->data['update'] = '';
		$form = new AForm('ST');

		$form->setForm(array(
			'form_name' => 'rpcFrm',
			'update' => $this->data['update'],
		));

		$this->data['form']['id'] = 'rpcFrm';
		$this->data['form']['form_open'] = $form->getFieldHtml(array(
			'type' => 'form',
			'name' => 'rpcFrm',
			'attr' => 'confirm-exit="true"',
			'action' => $this->data['action'],
		));

		$this->data['form']['fields'] = array();
		$this->data['form']['fields']['points_gained'] = $form->getFieldHtml(array(
			'type' => 'input',
			'name' => 'points_amount',
			'value' => $this->data['points_gained'],
			'style' => '',
		));

		$this->data['form']['fields']['comment'] = $form->getFieldHtml(array(
			'type' => 'textarea',
			'name' => 'comment',
			'value' => '',
			'style' => 'large-field',
		));

		$this->data['form']['submit'] = $form->getFieldHtml(array(
			'type' => 'button',
			'name' => 'submit',
			'text' => $this->language->get('button_save'),
			'style' => 'button1',
		));
		$this->data['form']['cancel'] = $form->getFieldHtml(array(
			'type' => 'button',
			'name' => 'cancel',
			'text' => $this->language->get('button_cancel'),
			'style' => 'button2',
		));

		$grid_settings = array (
			//id of grid
			'table_id' => 'reward_points_history',
			// url to load data from
			'url' => $this->html->getSecureURL('listing_grid/reward_points_history', '&customer_id=' . $this->request->get['customer_id']),
			// url to send data for edit / delete
			'editurl' => '',
			'multiselect'=>'false',
			// url to update one field
			'update_field' => '',
			// default sort column
			'sortname' => 'date_added',
			// actions
			'actions' => '',
			'columns_search' => false,
			'sortable' => true );

		$grid_settings ['colNames'] = array (
			'#',
			$this->language->get ( 'column_date_added' ),
			$this->language->get ( 'text_amount' ),
			$this->language->get ( 'text_action_type' ),
			$this->language->get ( 'text_modified_by' ),
			$this->language->get ( 'text_comment' ),
		);
		$grid_settings ['colModel'] = array (
			array (
				'name' => 'row_id',
				'index' => 'row_id',
				'width' => 10,
				'align' => 'center',
				'sortable' => false,
				'search' => false
			),
			array (
				'name' => 'date_added',
				'index' => 'date_added',
				'width' => 50,
				'align' => 'center',
				'sortable' => false,
				'search' => false
			),
			array (
				'name' => 'points_amount',
				'index' => 'points_amount',
				'width' => 50,
				'align' => 'center',
				'sortable' => false,
				'search' => false
			),
			array (
				'name' => 'action_type',
				'index' => 'action_type',
				'width' => 50,
				'align' => 'center',
				'sortable' => false
			),
			array (
				'name' => 'source',
				'index' => 'source',
				'width' => 20,
				'align' => 'center',
				'sortable' => false,
				'search' => false
			),
			array (
				'name' => 'comment',
				'index' => 'comment',
				'width' => 50,
				'align' => 'center',
				'sortable' => false,
				'search' => false
			),
		);

		$grid = $this->dispatch ( 'common/listing_grid', array ( $grid_settings ) );
		$this->view->assign ( 'listing_grid', $grid->dispatchGetOutput () );

		$this->data['form_title'] = $this->language->get('text_set_reward_points');
		$this->view->assign('help_url', $this->gen_help_url('reward_points') );
		$this->view->batchAssign( $this->data );

		$this->processTemplate('pages/extension/reward_points_customer.tpl' );
	}

	private function _get_product_tabs($product_id) {

		$this->loadLanguage('catalog/product');
		$this->data['tabs'] = array(
			array(
				'text' => $this->language->get('tab_general'),
				'href' => $this->html->getSecureURL('catalog/product/update', '&product_id=' . $product_id ),
				'class' => ''
			),
			array(
				'text' => $this->language->get('tab_media'),
				'href' => $this->html->getSecureURL('catalog/product_images', '&product_id=' . $product_id ),
				'class' => ''
			),
			array(
				'text' => $this->language->get('tab_relations'),
				'href' => $this->html->getSecureURL('catalog/product_relations', '&product_id=' . $product_id ),
				'class' => ''
			),
			array(
				'text' => $this->language->get('tab_option'),
				'href' => $this->html->getSecureURL('catalog/product_options', '&product_id=' . $product_id ),
				'class' => ''
			),
			array(
				'text' => $this->language->get('tab_promotions'),
				'href' => $this->html->getSecureURL('catalog/product_promotions', '&product_id=' . $product_id ),
				'class' => ''
			),
			array(
				'text' => $this->language->get('tab_extensions'),
				'href' => $this->html->getSecureURL('catalog/product_extensions', '&product_id=' . $product_id ),
				'class' => ''
			),
			array(
				'text' => $this->language->get('tab_layout'),
				'href' => $this->html->getSecureURL('catalog/product_layout', '&product_id=' . $product_id ),
				'class' => ''
			),
			array(
				'text' => $this->language->get('reward_points_name'),
				'href' => $this->html->getSecureURL(
					'extension/reward_points',
					'&object_id=' . $product_id .
					'&object_name=product'
				),
				'class' => 'active'
			),
		);
	}

	public function _get_category_tabs($category_id) {

		$this->loadLanguage('catalog/category');
		$this->data['tabs'] = array(
			array(
				'text' => $this->language->get('tab_general'),
				'href' => $this->html->getSecureURL('catalog/category/update', '&category_id=' . $category_id) . '#general',
				'class' => ''
			),
			array(
				'text' => $this->language->get('tab_data'),
				'href' => $this->html->getSecureURL('catalog/category/update', '&category_id=' . $category_id) . '#data',
				'class' => ''
			),
			array(
				'text' => $this->language->get('tab_image'),
				'href' => $this->html->getSecureURL('catalog/category/update', '&category_id=' . $category_id) . '#tab_media',
				'class' => ''
			),
			array(
				'text' => $this->language->get('tab_layout'),
				'href' => $this->html->getSecureURL('catalog/category/edit_layout', '&category_id=' . $category_id ),
				'class' => ''
			),
			array(
				'text' => $this->language->get('reward_points_name'),
				'href' => $this->html->getSecureURL(
					'extension/reward_points',
					'&object_id=' . $category_id .
					'&object_name=category'
				),
				'class' => 'active'
			),
		);
	}

	public function _get_manufacturer_tabs($manufacturer_id) {
		$this->loadLanguage('catalog/manufacturer');
		$this->data['tabs'] = array(
			array(
				'text' => $this->language->get('entry_edit'),
				'href' => $this->html->getSecureURL('catalog/manufacturer/update', '&manufacturer_id=' . $manufacturer_id),
				'class' => ''
			),
			array(
				'text' => $this->language->get('entry_layout'),
				'href' => $this->html->getSecureURL('catalog/manufacturer/edit_layout', '&manufacturer_id=' . $manufacturer_id ),
				'class' => ''
			),
			array(
				'text' => $this->language->get('reward_points_name'),
				'href' => $this->html->getSecureURL(
					'extension/reward_points',
					'&object_id=' . $manufacturer_id .
					'&object_name=manufacturer'
				),
				'class' => 'active'
			),
		);
	}

	private function _validateForm() {
		if (!$this->user->canModify('sale/customer')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}
	}

}